/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    E-folio A

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo de trabalho:

- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334

Ficheiro: ReportA.c

Report A: Lista das UCs que necessitam de tutores.
          - com mais de 70 alunos inscritos.
          Apresente a lista com código e nome da UC e nº de alunos.

*/

#include <stdio.h>
#include <stdlib.h>

#include "globals.h"
#include "ucs.h"
#include "inscricoes.h"
#include "ReportA.h"


FILE *rept;

/*
 Cabeçalho do Report
 */
void cab_report(char p_output, int p_ano)
{
    if (p_output != 'E')
    {
        fprintf(rept, "\n ANO LETIVO: %d / %d", p_ano, p_ano + 1);
        fprintf(rept, "\n UC                                       TOTAL ALUNOS");
        fprintf(rept,  "\n ------------------------------------------------------\n");

    }
    if (p_output != 'F')
    {
        clear();
        linha();
        printf(" ANO LETIVO: %d / %d", p_ano, p_ano + 1);
        linha();
        printf(" UC                                       TOTAL ALUNOS");
        linha();
        printf("------------------------------------------------------");
        linha();
    }
}


/*
 Imprime linha do report
 */
void imp_linha(char p_output, int p_numero, char *p_nome, int p_contador)
{
    if (p_output != 'E')
    {

        fprintf(rept,"%*d  %-30s    %*d\n", 6, p_numero, p_nome, 3, p_contador);
    }
    if (p_output != 'F')
    {
        printf("%*d  %-30s    %*d", 6, p_numero, p_nome, 3, p_contador);
        linha();
    }
}


/*
 Rodape do Report
 */
void imp_rodape(char p_output, int p_contador)
{
    if (p_output != 'E')
    {
        fprintf(rept, "\n\n TOTAL UCs : %d COM MAIS DE %d ALUNOS INSCRITOS", p_contador, MAX_ALUNOS);
        fprintf(rept,  "\n ------------------------------------------------------\n");

    }
    if (p_output != 'F')
    {
        linha();
        linha();
        printf(" TOTAL UCs : %d COM MAIS DE %d ALUNOS INSCRITOS", p_contador, MAX_ALUNOS);
        linha();
        printf("------------------------------------------------------");
        linha();
    }
}



/*
   Listar UCs que necessitam de TUTOR, ou seja, com mais do que o definido na constante MAX_ALUNOS
*/
void repA_UCs_tutor()
{
    INSCRICOES r_inscricao;
    UCS r_uc;
    int l_contador = 0;   // Flag para controlar se ja imprimiu o cabecalho ou nao
    int l_conta_alunos = 0;   // Declara contador de alunos por UC
    char l_output;        // Tipo Output da Listagem: E-Ecra, F-Ficheiro ou A-Ambos

    cabecalho("Reports: Listar UCs que necessitam Tutor");

    FILE *arq = abrir_ficheiro("ucs.dat","rb");
    if (arq != NULL)
    {
        int l_ano =  pergunta_numero("Ano Letivo: ");
        l_output = pergunta_output("Listagem para (E)cra, (F)icheiro ou (A)mbos: ");

        while ( fread( &r_uc, 1, sizeof(r_uc), arq ) == sizeof(r_uc) )
        {
           l_conta_alunos = 0;  // Inicializa a 0 o contador de alunos por UC

           if ( r_uc.eliminado == 0 )   // Apenas vou verificar as UCs activas, as eliminadas sao descartadas
           {
              FILE *arq2 = abrir_ficheiro("inscricoes.dat","rb");
              if (arq2 != NULL)
              {
                 while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq2 ) == sizeof(r_inscricao) )
                 {
                    if ( (r_inscricao.n_uc == r_uc.numero) &&
                         (r_inscricao.ano == l_ano) &&    // Apenas contabilizar inscriçoes para o ano pedido
                         (r_inscricao.eliminado == 0) )   // Nao sao contabilizadas inscricoes anuladas
                    {
                        l_conta_alunos++;    // incrementa o contador de numero de alunos na UC
                    }
                 }
                 if (l_conta_alunos > MAX_ALUNOS)
                 {
                     if (l_contador == 0)  // Se eh a 1a UC que vai listar, entao desenha o cabecalho
                     {
                         if (l_output != 'E')
                         {
                             rept = abrir_ficheiro("rep_tutor.txt", "w");
                         }
                         cab_report(l_output, l_ano);
                     }
                     l_contador++;   // Incrementa 1, numero de UCs a necessitar de tutor
                     imp_linha(l_output, r_uc.numero, r_uc.nome, l_conta_alunos);  // Imprime as linhas do report
                 }
                 fechar_ficheiro(arq2);
              }
           }
        }
        fechar_ficheiro(arq);
        if (l_contador == 0)
        {
            linha();
            printf(" Não existe nenhuma UC com mais de %d alunos inscritos", MAX_ALUNOS);
            linha();
            pause();
        }
        else
        {
            imp_rodape(l_output, l_contador);
            if (l_output != 'E')
            {
                linha();
                mensagem("Foi gerado um ficheiro com o nome rep_tutor.txt");
                linha();
                fechar_ficheiro(rept);
            }
            if (l_output == 'E') {
                pause();
            }
        }
    }
}


// Fim ficheiro "ReportA.c"
