/*
Sistema de gestao de inscriaoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: globals.c

MODULO 2 - GLOBALS
*/

#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <string.h>
#include <ctype.h>

#include "globals.h"


/*
   Linha de intervalo
*/
void linha()
{
   printf ("\n");
}


/*
   Cabecalho
   Caso receba algum texto como argumento, ent�o escreve como sub-titulo
*/
void cabecalho(char *p_descricao)
{
   clear();
   printf("\n-----------------------------------------------");
   printf("\n        Sistema de Gestao de Inscricoes        ");
   printf("\n     Licenciatura em Engenharia Informatica    ");
   printf("\n-----------------------------------------------");
   if (strlen(p_descricao) > 0)
   {
      printf("\n %s", p_descricao);
      printf("\n-----------------------------------------------");
   }
   linha();
}


/*
   #11 - Funcao pausa ate carregar numa tecla
*/
void pause()
{
     clear_buffer();
     printf("\n<ENTER> para continuar");
     getchar();
}


/*
   #11 - Funcao mensagem
*/
void mensagem(const char *p_mensagem)
{
   printf("\n %s",p_mensagem);
   pause();
}


/*
   Funcao para perguntar um numero inteiro
*/
int pergunta_numero(const char *p_mensagem)
 {
   int l_numero = 0;

   printf("\n %s",p_mensagem);
   clear_buffer();
   scanf("%d", &l_numero);

   return l_numero;
}

/*
   #6 - Validacao de campo obrigatorio
*/
int campo_obrigatorio_char(char p_campo[100])
{
    int     erro=0,
            tamanho;

   tamanho = strlen(p_campo);

   if (tamanho == 0)
   {
      printf("\nCampo de preenchimento obrigatorio!\n");
      erro = 1;
      pause();
   }

   return erro;
}


/*
   Funcao que pergunda s/n e retorna a resposta em maiusculas
*/
char gravar(const char *p_mensagem)
{
   char l_gravar;

   clear_buffer();
   printf("%s? (S/N)", p_mensagem );
   scanf("%c", &l_gravar);

   return toupper(l_gravar);
}


/*
 * * * Funçao recursiva * * *
 Pergunta tipo de output da listagem desejado:
    E - Ecran
    F - Ficheiro
    A - Ambos
 */
char pergunta_output(const char *p_mensagem)
{
    char l_output;

    clear_buffer();
    printf(" %s", p_mensagem );
    scanf("%c", &l_output);

    switch(toupper(l_output))
    {
        case 'E':
        case 'F':
        case 'A':
            break;
        default:
            mensagem("Valor Inválido");
            l_output = pergunta_output(p_mensagem);
    }

    return toupper(l_output);
}


/*
   Funcoes para abertura, fecho e teste de ficheiros
*/

// Abrir ficheiro
// rb- modo de leitura (binario)
// ab- modo de escrita (binario)
// w - modo de escrita (texto)
FILE* abrir_ficheiro(const char *p_ficheiro, const char *p_modo)
{

   FILE *arq = fopen(p_ficheiro,p_modo);

   if (arq == NULL)
   {
      mensagem("Nao foi possivel abrir o ficheiro");
      exit (0);
   }
   return arq;
}


// Fechar ficheiro
void fechar_ficheiro(FILE* p_ficheiro)
{
   fclose(p_ficheiro);
}



// fim ficheiro globals.c

