/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: globals.h

MODULO 2 - GLOBALS
*/


#ifndef GLOBALS_H_INCLUDED
#define GLOBALS_H_INCLUDED

// --------------------------------------------------------------------------------------------
// Esta condicao serve apenas para saber se estamos num sistema Windows ou outro (MacOs, Linux)
// apenas existe porque alguns comandos sao diferentes,

// clear()
// Em caso de estar no Windows o comando de sistema para limpar ecran � cls
// Nos restantes sistemas � clear

#ifdef _WIN32
#define clear() system("cls")
#else
#define clear() system("clear")
#endif

// clear_buffer()
// Em caso de estar no Windows o comando de sistema para limpar ecran  fflush()
// Nos restantes sistemas  fpurge()

#ifdef _WIN32
#define clear_buffer() fflush(stdin)
#else
#define clear_buffer() fpurge(stdin)
#endif

// --------------------------------------------------------------------------------------------
//
// Funcoes globais que podem ser usadas em qualquer programa
//

void cabecalho(char *p_descricao);  // Desenha o cabecalho do Interface
int pergunta_numero(const char *p_mensagem); // Pergunta um numero inteiro
void pause();      // Da mensagem de "Prima um tecla para continuar..." e fica a aguardar
char gravar();     // Pergunta se o utilizador quer ou nao gravar e retorna S ou N
void linha();      // Imprime uma linha em branco no ecran

void mensagem(const char *p_mensagem);            // Recebe uma mensagem e manda para o ecran
int campo_obrigatorio_char(char p_campo[100]);    // Valida se um campo esta ou nao preenchido
char pergunta_output(const char *p_mensagem);     // Pergunta que tipo de output deseja na listagem

FILE* abrir_ficheiro(const char *p_ficheiro, const char *p_modo);
void fechar_ficheiro(FILE* p_ficheiro);

#endif // GLOBALS_H_INCLUDED

// fim ficheiro "globals.h

