/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: menus.c

MODULO 3 - MENUS
*/

#include <stdio.h>
#include <stdlib.h>

#include "globals.h"
#include "menus.h"
#include "alunos.h"
#include "ucs.h"
#include "inscricoes.h"
#include "ReportA.h"
#include "ReportC.h"


/*
    Menu Manuseamento: Alunos
*/
void menu_alunos()
{

   int    opcao;
   char   l_nome[30];

   do
   {
      cabecalho("Alunos: Manuseamento");
      opcao = menu_manu(1);

      switch(opcao)
      {
         case 1:
            ins_aluno();
            break;

         case 2:
            cons_aluno(l_nome, 0, 0, 0);
            break;

         case 3:
             eli_aluno();
             break;

         case 4:
            mod_aluno();
         break;

         case 0:
            break;

         default:
            mensagem("Opcao invalida!");
            break;
      }
   }
   while (opcao != 0);
};


/*
   Menu Manuseamento de UCs
*/
void menu_ucs()
{
   int opcao;
   char l_nome[30];

   do
   {
      cabecalho("UCs: Manuseamento");
      opcao = menu_manu(2);

      switch(opcao)
      {
         case 1:
            ins_uc();
            break;

         case 2:
            cons_uc(l_nome,0,0,0,0);
            break;

         case 3:
            eli_uc();
            break;

         case 4:
            mod_uc();
            break;

         case 0:
            break;

         default:
            mensagem("Opcao invalida!");
            break;
      }

   }
   while (opcao !=0 );
};


/*
   Menu Manuseamento de Inscricoes
*/
void menu_inscricoes()
{
   int opcao;

   do
   {
      cabecalho("Inscricoes: Manuseamento");
      opcao = menu_manu(3);

      switch(opcao)
      {
         case 1:
            ins_inscricao();
            break;

         case 2:
            cons_inscricao();
            break;

         case 3:
            eli_inscricao();
            break;

         case 4:
            mod_inscricao();
            break;

         case 0:
            break;

         default:
            mensagem("Opcao invalida!");
            break;
      }

   }
   while (opcao !=0 );
};


/*
   Menu Manuseamento:
      1 - Aluno
      2 - UC
      3 - Inscricao
*/
int menu_manu(int p_tipo)
{
   int    opcao;
   char * l_descricao;

   if (p_tipo==1)
      l_descricao = "Aluno";
   else if (p_tipo==2)
        l_descricao = "UC";
        else
            l_descricao = "Inscricao";
   linha();
   printf("\n1 - Inserir %s",l_descricao);
   printf("\n2 - Consultar %s",l_descricao);

   if (p_tipo==3)
      printf("\n3 - Anular %s",l_descricao);
   else
      printf("\n3 - Eliminar %s",l_descricao);
   printf("\n4 - Modificar %s",l_descricao);
   printf("\n0 - Sair");

   linha();
   printf("Escolha uma opcao: ");
   scanf("%d",&opcao);

   return opcao;
}


void menu_consultas()
{
    int opcao;
    char l_nome[30];

   do
   {
      clear_buffer();
      cabecalho("Menu Consultas/Listagens");
      linha();
      printf("\n1 - Consultar Aluno");
      printf("\n2 - Listar UCs por Aluno");
      printf("\n3 - Consultar UC");
      printf("\n4 - Listar Alunos por UC");
      printf("\n0 - Sair");

      linha();
      printf("Escolha uma opcao: ");
      scanf("%d",&opcao);

      switch(opcao)
      {
         case 1:
            cons_aluno(l_nome, 0, 0, 0); //Função para consultar aluno
            break;

         case 2:
            lis_ucs_aluno(); // Função para listar as UCs em que um aluno esta inscrito
            break;

         case 3:
            cons_uc(l_nome,0,0,0,0); //Funcao para consultar UC's
            break;

         case 4:
            lis_alunos_uc(); // Função para listar os alunos inscritos numa UC
            break;

         case 0:
            break;

         default:
            mensagem("Opcao invalida!");
            break;
      }

   }
   while (opcao !=0 );
}


/*
  Menu propinas
*/
void menu_propinas()
{
    int opcao;

   do
   {
      clear_buffer();
      cabecalho("Menu Propinas");
      linha();
      printf("\n1 - Calcular Valor Atual");
      printf("\n0 - Sair");

      linha();
      printf("Escolha uma opcao: ");
      scanf("%d",&opcao);

      switch(opcao)
      {
         case 1:
            lis_propinas(); // Função para listar os alunos / propinas
            break;

         case 0:
            break;

         default:
            mensagem("Opcao invalida!");
            break;
      }

   }
   while (opcao !=0 );
}


/*
  Menu reports
*/
void menu_reports()
{
    int opcao;

    do
    {
        clear_buffer();
        cabecalho("Menu Reports");
        linha();
        printf("\n1 - UCs que necessitam de Tutor (A)");
        printf("\n2 - Regime de cada Aluno (C)");
        printf("\n0 - Sair");

        linha();
        printf("Escolha uma opcao: ");
        scanf("%d",&opcao);

        switch(opcao)
        {
            case 1:
                repA_UCs_tutor(); // Report A - Listagem de UCs que necessitam de Tutor
                break;

            case 2:
                regime_aluno();  // Report C - Regime de tempo de cada aluno (parcial, integral ou situação irregular).
                break;

            case 0:
                break;

            default:
                mensagem("Opcao invalida!");
                break;
        }

    }
    while (opcao !=0 );
}


/*
   Menu Principal
*/
int menu()
{

   int opcao;

   do
   {
      cabecalho("Menu Universidade");

      linha();
      printf("1 - Alunos");
      linha();
      printf("2 - UCs");
      linha();
      printf("3 - Inscricoes");
      linha();
      printf("4 - Consultas");
      linha();
      printf("5 - Propinas");
      linha();
      printf("6 - Reports");
      linha();
      printf("0 - Sair");
      linha();
      linha();

      printf("Escolha uma opcao: ");
      scanf("%d",&opcao);

      switch(opcao)
      {
         case 1:
            menu_alunos();
            break;

         case 2:
            menu_ucs();
            break;

         case 3:
            menu_inscricoes();
            break;

         case 4:
            menu_consultas();
            break;

         case 5:
            menu_propinas();
            break;

        case 6:
            menu_reports();
            break;

         case 0:
            cabecalho("                Volte Sempre!");
            break;

         default:
            mensagem("Opcao invalida!");
            break;
      }
   }
   while ( opcao != 0 );

   return 0;
};

// fim ficheiro "menus.c"

